import { getUserTags } from "./server/ab_test.event";
import { Network } from "pi_network/client_net/network";
import { CreateTagsParam } from './server/ab_test_table.struct';
import { getUserTags as getUserTagsTopic } from "./server/ab_test.topic";
import { getCurrentRid } from 'pi_common_tools/main';


let map: Map<string, string>;


/**
 * 获取用户指定name的标签
 * @param name 
 * @param channel 
 * @param os 
 * @returns 
 */
export const getUserAbTestTag = async (name: string, channel?: string, os?: string): Promise<string> => {
    const tags = await getUserAbTestTags(channel, os);
    return tags.get(name) || "";
}


/**
 * 获取用户所有标签
 * @param channel 
 * @param os 
 * @returns 
 */
export const getUserAbTestTags = async (channel?: string, os?: string): Promise<Map<string, string>> => {
    const param = new CreateTagsParam();
    param.rid = getCurrentRid().toString();
    param.channel = channel || "";
    param.os = os || "";

    if (!globalThis._$cwd) {
        if (map) return map;
        const result = await Network.mqtt.rpc(getUserTagsTopic, param, 2 * 1000);
        map = result;
        return map;

    } else {
        return getUserTags(param);
    }
}